CREATE TABLE IF NOT EXISTS `{#}parsing_cats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `default` int(11) DEFAULT '6',
  `parent` varchar(40) DEFAULT 'vesti',
  `cats` text,
  PRIMARY KEY (`id`),
  KEY `parent` (`parent`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

INSERT INTO `{#}parsing_cats` (`default`, `parent`, `cats`) VALUES
(6, '1', '---\nПолитика: 4\nЭкономика: 3\nПроисшествия: 5\nОбщество: 2\nКультура: 2\nСпорт: 7\nВ мире: 6\n'),
(6, '2', '---\nПолитика: 4\nОбщество: 2\nЭкономика: 3\nПроисшествия: 5\nСпорт: 7\nКультура: 2\nВ мире: 6\nРелигия: 2\n');


CREATE TABLE IF NOT EXISTS `{#}parsing_filters` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parent` varchar(40) DEFAULT NULL,
  `title` varchar(40) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `parent` (`parent`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

CREATE TABLE IF NOT EXISTS `{#}parsing_sources` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL,
  `url` varchar(255) NOT NULL,
  `url_list` varchar(255) NOT NULL,
  `url_search` varchar(255) DEFAULT NULL,
  `selectors` text NOT NULL,
  `rules` text,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

INSERT INTO `{#}parsing_sources` (`name`, `url`, `url_list`, `url_search`, `selectors`, `rules`) VALUES
('Вести', 'http://www.vesti.ru', 'http://www.vesti.ru/news', 'http://www.vesti.ru/search/index/?q={$filtr}&news=1&video=0', 'list : .news-wrapper_ h3.b-item__title a\nlist_search : .search-results .search-item__content h3 a\ntitle : meta[property="og:title"]\nteaser : meta[property="og:description"]\nimage : meta[property="og:image"]\ncategory : .breadcrumbs a:nth-child(2)\ntext : .article .article__text', 'href : 13 | /doc.html?id='),
('РИА новости', 'https://ria.ru', 'https://ria.ru/lenta', 'https://ria.ru/services/search/getmore/?query={$filtr}', 'list : div.b-list__item a\nlist_search : div.b-list__item a\ntitle : meta[property="og:title"]\nimage : meta[property="og:image"]\ncategory : .b-page-title__text a\ntext : .b-article__ind .b-article__body\nremove : .b-article__ind .b-article__body .b-inject, .b-article__ind .b-article__body .b-banner', NULL);

DELETE FROM `{#}scheduler_tasks` WHERE `controller` = 'parsing';
INSERT INTO `{#}scheduler_tasks` (`title`, `controller`, `hook`, `period`, `date_last_run`, `is_active`, `is_new`) VALUES
('Парсинг новостей', 'parsing', 'parsing', 60, NULL, 1, 1);