<?php

class backendParsing extends cmsBackend {
	
	public $useDefaultOptionsAction = true;
	protected $useOptions = true;
	public $default_cat = 6;
	public $sizes = array('micro', 'small', 'normal', 'big');

	public function __construct($request) {
        parent::__construct($request);
		ini_set('error_reporting', E_ALL);
		ini_set('display_errors', 1);
		ini_set('display_startup_errors', 1);
        cmsCore::includeFile('system/controllers/parsing/lib/bootstrap.php');
		$this->sizes = $this->model->selectOnly('i.id, i.options')->getItemByField('con_news_fields', 'name', 'photo', function($item, $model){
            $item['options'] = !empty($item['options']) ? cmsModel::yamlToArray($item['options']) : false;
            return !empty($item['options']['sizes']) ? $item['options']['sizes'] : array('micro', 'small', 'normal', 'big');
        });
    }

	public function actionIndex(){
		$this->redirectToAction('sources');		
	}
	
	public function actionCache(){
		$cache_dir = cmsConfig::get('root_path') . "/system/controllers/parsing/cache/";
		if(file_exists($cache_dir)){
			foreach(glob($cache_dir.'*') as $file){unlink($file);}
		}
		$this->redirectBack();
	}
	
	public function getBackendMenu() {
		return array(
			array(
				'title' => 'Источники',
				'url' => href_to($this->root_url, 'sources')
			),
			array(
                'title' => LANG_OPTIONS,
                'url' => href_to($this->root_url, 'options')
            ),
			array(
				'title' => 'Очистить кэш',
				'url' => href_to($this->root_url, 'cache')
			)
		);		
	}
	
}

