<?php

use DiDom\Document;

class actionParsingAjax extends cmsAction {

    public function run($id = false, $filtr = false){
        if(!$this->request->isAjax() || !$id || !is_numeric($id)){cmsCore::error404();}

		$source = $this->model->getSources($id);
		if (!$source) { cmsCore::error404(); }

		$source['rules'] = $source['rules'] ? cmsModel::yamlToArray($source['rules']) : false;
		$source['selectors'] = $source['selectors'] ? cmsModel::yamlToArray($source['selectors']) : false;
		if (!$source['selectors'] || !is_array($source['selectors'])) { cmsCore::error404(); }

		$base_url = (isset($source['rules']['no_domain']) && $source['rules']['no_domain']) ? false : $source['url'];

        $grid = $this->loadDataGrid('sources', $base_url);
		$list = $this->getList($source, urlencode($filtr));
        $this->cms_template->renderGridRowsJSON($grid, $list);
        $this->halt();
    }

	public function getList($source, $filtr = false){
		$filename = $filtr ? $source['id'] . '_' . urldecode($filtr) : $source['id'];
		$date = date("ymd");
		$cache = cmsConfig::get('root_path') . "/system/controllers/parsing/cache/{$filename}_{$date}.yml";
		$cache_date = substr($cache, -10, 6);
		$data = array();
		if(file_exists($cache) && $cache_date == date("ymd")){
			$result = @file_get_contents($cache);
			$data = cmsModel::yamlToArray($result);
		} else {

			$url = $filtr ? str_replace('{$filtr}', $filtr, $source['url_search']) : $source['url_list'];
			
			if (isset($source['rules']['is_rss']) && $source['rules']['is_rss'] && !$filtr) {
				$document = $url;
			} else {
				if (isset($source['rules']['curl']) && $source['rules']['curl']) {			
					$html = $this->model->curl_get_contents($url);
				} else {
					$html = @file_get_contents($url);
				}
				$document = $html ? new Document($html) : false;
			}

			if ($document) {
				
				cmsCore::loadLib('parsing.helper');

				$data = getParsingList($document, $source, $filtr);
				
				if(is_writable(dirname($cache))){
					$cache_yaml = cmsModel::arrayToYaml($data);
					@file_put_contents($cache, $cache_yaml);
				}
			}
		}

		return $data;

	}

}