<?php

use DiDom\Document;

class actionParsingAuto extends cmsAction {

    public function run($id = false, $item_id = false, $filtr = false){

		$item = false;
		if(!$id || !is_numeric($id) || !$item_id || !is_numeric($item_id)){
			cmsUser::addSessionMessage('Неизвестный параметр URL', 'error');
			$this->redirectBack();
		}

		$source = $this->model->getSources($id);
		if (!$source) { cmsCore::error404(); }

		$filename = $filtr ? $id . '_' . urldecode($filtr) : $id;
		$date = date("ymd");
		$data = array();
		$cache = $this->cms_config->root_path . "/system/controllers/parsing/cache/{$filename}_{$date}.yml";

		if(file_exists($cache)){
			$result = @file_get_contents($cache);
			$data = cmsModel::yamlToArray($result);
		} else {
			cmsUser::addSessionMessage('Кэш-файл устарел или не найден, попробуйте очистить кэш', 'error');
			$this->redirectBack();
		}

		if($data && isset($data[$item_id]) && $data[$item_id] && isset($data[$item_id]['url']) && $data[$item_id]['url']){

			$source['rules'] = $source['rules'] ? cmsModel::yamlToArray($source['rules']) : false;
			$source['selectors'] = $source['selectors'] ? cmsModel::yamlToArray($source['selectors']) : false;
			if (!$source['selectors'] || !is_array($source['selectors'])) { 
				cmsUser::addSessionMessage('Селекторы не найдены', 'error');
				$this->redirectBack();
			}

			if (!empty($source['rules']['no_domain']) || !empty($source['rules']['is_rss'])) {
				if (substr($data[$item_id]['url'], 0, 1) == '/'){
					$url = $source['url'] . $data[$item_id]['url'];
				} else {
					$url = $data[$item_id]['url'];
				}
			} else {
				$pos = strpos($data[$item_id]['url'], $source['url']);
				if ($pos === false) {
					$url = $source['url'] . $data[$item_id]['url'];
				} else {
					$url = $data[$item_id]['url'];
				}
			}

			$hash = $url;

			$is_add = $this->model->selectOnly('i.id, i.pars_id')->getItemByField('con_news', 'pars_id', $hash);
			if($is_add){
				cmsUser::addSessionMessage('Эта новость уже добавлена', 'error');
				$this->redirectBack();
			}

			if (isset($source['rules']['curl']) && $source['rules']['curl']) {			
				$html = $this->model->curl_get_contents($url);
			} else {
				$html = @file_get_contents($url);
			}

			$document = $html ? new Document($html) : false;

			if ($document) {

				cmsCore::loadLib('parsing.helper');

				list($item, $cat) = getParsingData($this, $document, $source, $item, $url);

			} else {
				cmsUser::addSessionMessage('Не удалось получить данные', 'error');
				$this->redirectBack();
			}

			if($item){
				$content = cmsCore::getController('content');
				$content->request->set('csrf_token', cmsForm::getCSRFToken());
				$content->request->set('category_id', $this->default_cat);
				$cats = $this->model->getSourceCats($id);
				if($cats){
					$item['category_id'] = (isset($cats['cats'][$cat])) ? $cats['cats'][$cat] : $cats['default'];
					$content->request->set('category_id', $item['category_id']);
				}
				$content->request->set('is_private', 0);
				$today = array('date' => date("d.m.Y"), 'hours' => date("H"), 'mins' => date("i"));
				$content->request->set('date_pub', $today);
				$content->request->set('title', $item['title']);
				$content->request->set('pars_id', $hash);
				if(isset($item['photo']) && $item['photo']){$content->request->set('photo', $item['photo']);}
				$content->request->set('content', $item['content']);			
				$content->request->set('teaser', $item['teaser']);			
				$content->request->set('submit', 'Сохранить');
				$content->request->set('ctype_name', 'news');
				$content->request->set('is_comments_on', 1);
				$content->request->set('is_pub', 1);
				$content->request->set('back', $_SERVER['HTTP_REFERER']);
				$content->runAction('item_add');
			}
		}

		cmsUser::addSessionMessage('Что то пошло не так', 'error');
		$this->redirectBack();

    }

}