<?php

class actionParsingCats extends cmsAction {

    public function run($id = false){
		
		if(!$id || !is_numeric($id)){cmsCore::error404();}
		
		$source = $this->model->getSources($id);
		if (!$source) { cmsCore::error404(); }
		
		$source['selectors'] = $source['selectors'] ? cmsModel::yamlToArray($source['selectors']) : false;
		if (!$source['selectors'] || !is_array($source['selectors'])) { cmsCore::error404(); }
		
		$items = $this->model->getSourceCats($id);
        $form = $this->getForm('cats');
		
		if(!isset($source['selectors']['category'])){
			$form->removeFieldset(1);
		}
		
		$is_submitted = $this->request->has('submit');
		if($is_submitted){
			$cats = $form->parse($this->request, $is_submitted);
            $errors = $form->validate($this, $cats);			
            if(!$errors){
				$cats['parent'] = $id;
				if(!empty($cats['cats'])){
					$list = false;
					foreach($cats['cats'] as $key => $cat){
						if(is_string($cat) && isset($cats['cats'][$key + 1]) && is_numeric($cats['cats'][$key + 1])){
							$list[$cat] = $cats['cats'][$key + 1];
						}
					}
					$cats['cats'] = $list;
				}
				if($items){					
					$this->model->updateSourceCats($items['id'], $cats);
				} else {
					$this->model->addSourceCats($cats);
				}
				$this->redirectToAction('sources', $id);
			} else {cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');}
		}
		return $this->cms_template->render('backend/cats', array(
            'do' => $items ? 'edit' : 'add',
            'cats' => isset($cats) ? $cats : $items,
            'form' => $form,
            'id' => $id,
            'source' => $source['name'],
            'errors' => isset($errors) ? $errors : false
        ));
    }

}