<?php

class actionParsingFilter extends cmsAction {

    public function run($id = false, $title = false, $delete = false){
		
		if(!$id || !is_numeric($id)){cmsCore::error404();}
		
		$source = $this->model->selectOnly('i.id')->getSources($id);
		if (!$source) { cmsCore::error404(); }
		
        if($title){
			$filter = $this->model->selectOnly('i.id')->getFilterByTitle($title);
			if(!$filter){cmsCore::error404();}
			$filter_id = $filter['id'];
			if($delete){
				$this->model->deleteFilter($filter_id);
				$this->redirectBack();
			}
		}
        $form = $this->getForm('filter');
		$is_submitted = $this->request->has('submit');
		if($is_submitted){			
			$filter = $form->parse($this->request, $is_submitted);
            $errors = $form->validate($this, $filter);			
            if(!$errors){
				if($title){
					$filter_id = $this->model->updateFilter($filter_id, $filter);
				} else {
					$filter_id = $this->model->addFilter($filter);
				}
				$this->redirectToAction('sources', $id);
			} else {cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');}
		}
		return $this->cms_template->render('backend/filter', array(
            'do' => $title ? 'edit' : 'add',
            'filter' => isset($filter) ? $filter : false,
            'form' => $form,
            'id' => $id,
            'errors' => isset($errors) ? $errors : false
        ));
    }

}