<?php

use DiDom\Document;

class actionParsingSelected extends cmsAction {

    public function run($id = false, $filtr = false){

		$item = false;
		$source = $this->model->getSources($id);
		if (!$source) { cmsCore::error404(); }

		$items = $this->request->get('selected', array());
        if (!$items) { cmsCore::error404(); }
		
		$filename = $filtr ? $id . '_' . urldecode($filtr) : $id;
		$date = date("ymd");
		$data = array();
		$selected = array();
		$cache = $this->cms_config->root_path . "/system/controllers/parsing/cache/{$filename}_{$date}.yml";

		if(file_exists($cache)){
			$result = @file_get_contents($cache);
			$data = cmsModel::yamlToArray($result);
		} else {
			cmsUser::addSessionMessage('Кэш-файл устарел или не найден, попробуйте очистить кэш', 'error');
			$this->redirectBack();
		}

		if($data && is_array($data)){
			foreach($items as $key){
				if(isset($data[$key])){
					$selected[$key] = $data[$key];
				}
			}
        }

		if($selected && is_array($selected)){

			$source['rules'] = $source['rules'] ? cmsModel::yamlToArray($source['rules']) : false;
			$source['selectors'] = $source['selectors'] ? cmsModel::yamlToArray($source['selectors']) : false;
			if (!$source['selectors'] || !is_array($source['selectors'])) {
				cmsUser::addSessionMessage('Селекторы не найдены', 'error');
				$this->redirectBack();
			}
			
			cmsCore::loadLib('parsing.helper');

			foreach($selected as $select){

				if(isset($select['url']) && $select['url']){

					if (!empty($source['rules']['no_domain']) || !empty($source['rules']['is_rss'])) {
						if (substr($select['url'], 0, 1) == '/'){
							$url = $source['url'] . $select['url'];
						} else {
							$url = $select['url'];
						}
					} else {
						$pos = strpos($select['url'], $source['url']);
						if ($pos === false) {
							$url = $source['url'] . $select['url'];
						} else {
							$url = $select['url'];
						}
					}

					$hash = $url;

					$is_add = $this->model->selectOnly('i.id, i.pars_id')->getItemByField('con_news', 'pars_id', $hash);
					if($is_add){continue;}

					if (isset($source['rules']['curl']) && $source['rules']['curl']) {			
						$html = $this->model->curl_get_contents($url);
					} else {
						$html = @file_get_contents($url);
					}

					$document = $html ? new Document($html) : false;

					if ($document) {

						list($item, $cat) = getParsingData($this, $document, $source, $item, $url, true);

					} else {continue;}

					if($item){
						$content = cmsCore::getController('content');
						$content->request->set('csrf_token', cmsForm::getCSRFToken());
						$content->request->set('category_id', $this->default_cat);
						$cats = $this->model->getSourceCats($id);
						if($cats){
							$item['category_id'] = (isset($cats['cats'][$cat])) ? $cats['cats'][$cat] : $cats['default'];
							$content->request->set('category_id', $item['category_id']);
						}
						$content->request->set('is_private', 0);
						$today = array('date' => date("d.m.Y"), 'hours' => date("H"), 'mins' => date("i"));
						$content->request->set('date_pub', $today);
						$content->request->set('title', $item['title']);
						$content->request->set('pars_id', $hash);
						if(isset($item['photo']) && $item['photo']){$content->request->set('photo', $item['photo']);}
						$content->request->set('content', $item['content']);			
						$content->request->set('teaser', $item['teaser']);			
						$content->request->set('submit', 'Сохранить');
						$content->request->set('ctype_name', 'news');
						$content->request->set('is_comments_on', 1);
						$content->request->set('is_pub', 1);
						$content->request->set('back', '/admin/controllers/edit/parsing/sources');
						$content->redirect = function(){return true;};
						$content->runAction('item_parse');
					}

					continue;

				} else {continue;}
			}
		}

        $this->redirectBack();

    }

}