<?php

class actionParsingSources extends cmsAction {

    public function run($id = 1){

		$sources = $this->model->getSources();
		if (!$sources || !$sources[$id]) { cmsCore::error404(); }

		$source = $sources[$id];
		
		$base_url = (isset($source['rules']['no_domain']) && $source['rules']['no_domain']) ? false : $source['url'];

        $grid = $this->loadDataGrid('sources', $base_url);
		$filters = $this->model->getFilters($id);
        return $this->cms_template->render('backend/sources', array(
			'grid' => $grid,
			'filters' => $filters,
			'sources' => $sources,
			'source' => $source,
			'open_new_window' => (isset($this->options['open_new_window']) && $this->options['open_new_window']) ? 1 : 0
		));
    }

}