<?php

use DiDom\Document;

class actionParsingView extends cmsAction {

    public function run($id = false, $item_id = false, $filtr = false){
		$item = false;
		if(!$id || !is_numeric($id) || !$item_id || !is_numeric($item_id)){
			dump('<p style="margin:15px">Неизвестный параметр URL</p>');
		}

		$source = $this->model->getSources($id);
		if (!$source) { cmsCore::error404(); }

		$filename = $filtr ? $id . '_' . urldecode($filtr) : $id;
		$date = date("ymd");
		$data = array();
		$cache = $this->cms_config->root_path . "/system/controllers/parsing/cache/{$filename}_{$date}.yml";

		if(file_exists($cache)){
			$result = @file_get_contents($cache);
			$data = cmsModel::yamlToArray($result);
		} else {
			dump('<p style="margin:15px">Кэш-файл устарел или не найден, попробуйте очистить кэш</p>');
		}

		if($data && isset($data[$item_id]) && $data[$item_id] && isset($data[$item_id]['url']) && $data[$item_id]['url']){
			
			$source['rules'] = $source['rules'] ? cmsModel::yamlToArray($source['rules']) : false;
			$source['selectors'] = $source['selectors'] ? cmsModel::yamlToArray($source['selectors']) : false;
			if (!$source['selectors'] || !is_array($source['selectors'])) {
				dump('<p style="margin:15px">Селекторы не найдены</p>');
			}

			if (!empty($source['rules']['no_domain']) || !empty($source['rules']['is_rss'])) {
				if (substr($data[$item_id]['url'], 0, 1) == '/'){
					$url = $source['url'] . $data[$item_id]['url'];
				} else {
					$url = $data[$item_id]['url'];
				}
			} else {
				$pos = strpos($data[$item_id]['url'], $source['url']);
				if ($pos === false) {
					$url = $source['url'] . $data[$item_id]['url'];
				} else {
					$url = $data[$item_id]['url'];
				}
			}

			$hash = $url;

			$item_cache = $this->cms_config->root_path . "/system/controllers/parsing/cache/{$id}_{$hash}.yml";
			if(file_exists($item_cache)){
				$get_cache = @file_get_contents($item_cache);
				$item = cmsModel::yamlToArray($get_cache);
			} else {

				if (isset($source['rules']['curl']) && $source['rules']['curl']) {			
					$html = $this->model->curl_get_contents($url);
				} else {
					$html = @file_get_contents($url);
				}

				$document = $html ? new Document($html) : false;
				
				if ($document) {

					cmsCore::loadLib('parsing.helper');

					$item = viewParsingData($this, $document, $source, $item, $url);

				} else {
					dump('<p style="margin:15px">Не удалось получить данные</p>');
				}

				if($item && is_writable(dirname($item_cache))){
					$cache_yaml = cmsModel::arrayToYaml($item);
					@file_put_contents($item_cache, $cache_yaml);
				}
            }

		}

		return $this->cms_template->render('pre_view', array(
			'item' => $item
		));

		dump('<p style="margin:15px">Что то пошло не так</p>');
    }

}