<?php

class formParsingCats extends cmsForm {

    public function init() {
		
		$cats_list = array();
		$content_model = cmsCore::getModel('content');
		$cats = $content_model->getCategoriesTree('news', false);

		if($cats){
			foreach($cats as $cat){
				if ($cat['ns_level'] > 1){
					$cat['title'] = str_repeat('-', $cat['ns_level']) . ' ' . $cat['title'];
				}
				$cats_list[$cat['id']] = $cat['title'];
			}
		}
		
        return array(
            array(
                'type' => 'fieldset',
				'title' => 'Категория по умолчанию',
                'childs' => array(
				
					new fieldList('default', array(						
						'hint' => 'Если категория не найдена, новости попадают на эту категорию',
						'default' => 6,
						'rules' => array(array('required')),
						'items' => $cats_list
					))

                )
            ),
			
			array(
                'type' => 'fieldset',
				'title' => LANG_ADDITIONAL_CATEGORIES,
                'childs' => array(
				
					new fieldParsingcats('cats')

                )
            ),

        );
    }
}

class fieldParsingcats extends cmsFormField {

    public function getNewsCats(){
		
		$content_model = cmsCore::getModel('content');
		$cats = $content_model->getCategoriesTree('news', false);

        return $cats;

    }
	
	public function getInput($value){

		$tpl_file = cmsTemplate::getInstance()->getTemplateFileName('controllers/parsing/parsingcats');

        ob_start();

        extract(array('field' => $this, 'value' => $value));
		include($tpl_file);

        return ob_get_clean();

    }

}