<?php

function grid_sources($controller, $base_url = false){

	$id = isset($controller->current_params[2]) ? $controller->current_params[2] : false;

    $options = array(
        'is_auto_init' => false, 
        'is_sortable' => false,
        'is_filter' => false,
        'is_pagination' => false,
        'is_draggable' => false,
		'is_selectable' => true,
        'show_id' => true
    );

    $columns = array(
        'id' => array(
            'title' => 'id',
            'width' => 20,
        ),
        'title' => array(
            'title' => LANG_TITLE,
            'href' => href_to($controller->root_url, 'auto', array($id, '{id}'))
        ),
        'url' => array(
            'title' => 'URL',
			'href' => $base_url ? $base_url . '{url}' : '{url}',
			'handler' => function ($url){
				return $url ? 'Оригинал' : LANG_NO;
			}
        )
    );

    $actions = array(
        array(
            'title' => 'Авто-добавление',
            'class' => 'play',
            'href' => href_to($controller->root_url, 'auto', array($id, '{id}')),
        ),
		array(
            'title' => 'Ручное-добавление',
            'class' => 'fields',
            'href' => href_to($controller->root_url, 'create', array($id, '{id}')),
        ),
		array(
            'title' => 'Просмотр',
            'class' => 'view',
            'href' => href_to($controller->root_url, 'view', array($id, '{id}')),
        ),
    );

    return array(
        'options' => $options,
        'columns' => $columns,
        'actions' => $actions
    );

}

