<?php 
class parsing extends cmsFrontend{
	
	protected $useOptions = true;
	public $default_cat = 6;
	public $sizes = array('micro', 'small', 'normal', 'big');
	
	public function __construct($request) {
        parent::__construct($request);
		ini_set('error_reporting', E_ALL);
		ini_set('display_errors', 1);
		ini_set('display_startup_errors', 1);
		$this->sizes = $this->model->selectOnly('i.id, i.options')->getItemByField('con_news_fields', 'name', 'photo', function($item, $model){
            $item['options'] = !empty($item['options']) ? cmsModel::yamlToArray($item['options']) : false;
            return !empty($item['options']['sizes']) ? $item['options']['sizes'] : array('micro', 'small', 'normal', 'big');
        });
    }
	
	public function actionImport($secret_key = false, $ctype_name = 'news'){

		if (!$secret_key){ cmsCore::error404(); }
		
		if (empty($this->options['secret_key'])){
			dump('Заполните поле Секретный ключ в настройках парсера');
		}
		
		if ($this->options['secret_key'] != $secret_key){
			dump('Секретный ключ не правильный');
		}
		
		$form = new cmsForm();
		
		$form->addFieldset('Импорт', 'import');
		
		$form->addField('import', new fieldFile('file', array(
			'title' => 'Файл',
			'options' => array('extensions' => 'json'),
			'rules' => array(
				array('required')
			)
		)));
		
		$is_submitted = $this->request->has('submit');

        if($is_submitted){
            $file = $form->parse($this->request, $is_submitted);
            $errors = $form->validate($this,  $file);
            if (!$errors){
				$json = $this->cms_config->upload_path . $file['file']['path'];
				if (file_exists($json)) {
					$data = strip_tags(trim(file_get_contents($json)), '<p></p><i></i>');
					$data = substr(htmlspecialchars($data, ENT_COMPAT),0,strlen(htmlspecialchars($data, ENT_COMPAT))-3);
					$news_list = $data ? json_decode(html_entity_decode($data . ']'), true) : false;
					if (json_last_error() == '0' && $news_list){
						cmsCore::loadLib('parsing.helper');
						$content = cmsCore::getController('content');
						$count = 0;
						$item = false;
						foreach($news_list as $news){
							if (empty($news['url'])){ continue; }
							$is_add = $this->model->selectOnly('i.id, i.pars_id')->getItemByField("con_{$ctype_name}", 'pars_id', $news['url']);
							if($is_add){continue;}
							unset($news['id']);
							$item = addImportData($this, $news, $ctype_name);
							if ($item){
								foreach($item as $i_key => $i_value){
									if (!empty($i_value)){
										$content->request->set($i_key, $i_value);
									}
								}
								$item['category_id'] = isset($item['category_id']) ? $item['category_id'] : $this->default_cat;
								$content->request->set('csrf_token', cmsForm::getCSRFToken());
								$content->request->set('category_id', $item['category_id']);
								$content->request->set('is_private', 0);
								$today = array('date' => date("d.m.Y"), 'hours' => date("H"), 'mins' => date("i"));
								$content->request->set('date_pub', $today);
								$content->request->set('pars_id', $news['url']);
								$content->request->set('submit', 'Сохранить');
								$content->request->set('ctype_name', $ctype_name);
								$content->request->set('is_comments_on', 1);
								$content->request->set('is_pub', 1);
								$content->request->set('back', $_SERVER['HTTP_REFERER']);
								$content->redirect = function(){return true;};
								$content->runAction('item_parse');
								$count++;
							}
						}
						
						cmsUser::addSessionMessage('Добавлено: ' . html_spellcount($count,'новость|новости|новостей'),'info');

					} else {
						cmsUser::addSessionMessage("Ошибка JSON синтаксиса", 'error');
						$this->redirectBack();
					}
				} else {
					cmsUser::addSessionMessage("Файл $json не существует", 'error');
					$this->redirectBack();
				}
			} else {
				cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
			}
        }

        return $this->cms_template->render('import', array(
            'file' => isset($file) ? $file : false,
            'form' => $form,
            'errors' => isset($errors) ? $errors : false
        ));
	}
	
}