<?php

use DiDom\Document;

class onParsingCronParsing extends cmsAction {
	
	public $sizes = array('micro', 'small', 'normal', 'big');

	public function __construct($request) {
        parent::__construct($request);
		ini_set('error_reporting', E_ALL);
		ini_set('display_errors', 1);
		ini_set('display_startup_errors', 1);
        cmsCore::includeFile('system/controllers/parsing/lib/bootstrap.php');
		$user = cmsUser::getInstance();
        $user->id = 1;
        $user->is_admin = 1;
        $user->is_logged = 1;
        $user->files_count = 60;
        $user->karma = 60;
        $user->groups = array(0 => 6);
		$this->sizes = $this->model->selectOnly('i.id, i.options')->getItemByField('con_news_fields', 'name', 'photo', function($item, $model){
            $item['options'] = !empty($item['options']) ? cmsModel::yamlToArray($item['options']) : false;
            return !empty($item['options']['sizes']) ? $item['options']['sizes'] : array('micro', 'small', 'normal', 'big');
        });
    }

	public function run(){
		$allowed = isset($this->model->options['cron']) ? $this->model->options['cron'] : false;
		$count = 0;
		if($allowed && is_array($allowed)){
			
			cmsCore::loadLib('parsing.helper');
			
			foreach($allowed as $key => $id){
				$item = false;
				$source = $this->model->getSources($id);
				if (!$source) { continue; }
				$source['rules'] = $source['rules'] ? cmsModel::yamlToArray($source['rules']) : false;
				$source['selectors'] = $source['selectors'] ? cmsModel::yamlToArray($source['selectors']) : false;
				if (!$source['selectors'] || !is_array($source['selectors'])) { cmsCore::error404(); }

				$filters = $this->model->getFilters($id);
				if (!$filters) { continue; }
				
				if($filters){
					foreach($filters as $filtr){
						$lists = $this->getList($source, urlencode($filtr['title']));
						if($lists){
							foreach($lists as $list){
								if(isset($list['url']) && $list['url']){

									if (!empty($source['rules']['no_domain']) || !empty($source['rules']['is_rss'])) {
										if (substr($list['url'], 0, 1) == '/'){
											$url = $source['url'] . $list['url'];
										} else {
											$url = $list['url'];
										}
									} else {
										$pos = strpos($list['url'], $source['url']);
										if ($pos === false) {
											$url = $source['url'] . $list['url'];
										} else {
											$url = $list['url'];
										}
									}

									$hash = $url;

									$is_add = $this->model->selectOnly('i.id, i.pars_id')->getItemByField('con_news', 'pars_id', $hash);
									if($is_add){continue;}

									if (isset($source['rules']['curl']) && $source['rules']['curl']) {			
										$html = $this->model->curl_get_contents($url);
									} else {
										$html = @file_get_contents($url);
									}

									$document = $html ? new Document($html) : false;

									if ($document) {

										list($item, $cat) = getParsingData($this, $document, $source, $item, $url, true);

									} else {continue;}

									if($item){
										$content = cmsCore::getController('content');
										$content->request->set('csrf_token', cmsForm::getCSRFToken());
										$content->request->set('category_id', $this->model->default_cat);
										$cats = $this->model->getSourceCats($id);
										if($cats){
											$item['category_id'] = (isset($cats['cats'][$cat])) ? $cats['cats'][$cat] : $cats['default'];
											$content->request->set('category_id', $item['category_id']);
										}
										$content->request->set('is_private', 0);
										$today = array('date' => date("d.m.Y"), 'hours' => date("H"), 'mins' => date("i"));
										$content->request->set('date_pub', $today);
										$content->request->set('title', $item['title']);
										$content->request->set('pars_id', $hash);
										if(isset($item['photo']) && $item['photo']){$content->request->set('photo', $item['photo']);}
										$content->request->set('content', $item['content']);			
										$content->request->set('teaser', $item['teaser']);			
										$content->request->set('submit', 'Сохранить');
										$content->request->set('ctype_name', 'news');
										$content->request->set('is_comments_on', 1);
										$content->request->set('is_pub', 1);
										$content->request->set('back', '/admin/settings/scheduler');
										$content->redirect = function(){return true;};
										$content->runAction('item_parse');
									}
									$count++;
									continue;

								} else {continue;}
							}
						}
					}
				}

			}
		}

		cmsUser::addSessionMessage('Добавлено: ' . html_spellcount($count, 'новость|новости|новостей'), 'info');

	}

	public function getList($source, $filtr = false){
		if(!$filtr){return false;}
		$url = str_replace('{$filtr}', $filtr, $source['url_search']);
		$data = array();
		if (isset($source['rules']['is_rss']) && $source['rules']['is_rss'] && !$filtr) {
			$document = $url;
		} else {
			if (isset($source['rules']['curl']) && $source['rules']['curl']) {			
				$html = $this->model->curl_get_contents($url);
			} else {
				$html = @file_get_contents($url);
			}
		}

		$document = $html ? new Document($html) : false;

		if ($document) {

			cmsCore::loadLib('parsing.helper');

			$data = getParsingList($document, $source, $filtr);

		}
		return $data;
	}

}