<?php
	$this->addCSS('templates/default/css/datatree.css');
    $this->addJS('templates/default/js/jquery-ui.js');
    $this->addJS('templates/default/js/jquery-cookie.js');
    $this->addJS('templates/default/js/datatree.js');
	$this->addJS('templates/default/controllers/parsing/js/jquery.contextMenu-custom.js');
    $this->setPageTitle($source['name']);
    $this->addBreadcrumb($source['name']);
	$id = $source['id'];
	$this->addToolButton(array(
		'class' => 'add',
		'title' => 'Добавить фильтр',
		'href'  => $this->href_to('filter', $id)
	));
	$this->addToolButton(array(
		'class' => 'tree_folder',
		'title' => 'Установка категории',
		'href'  => $this->href_to('cats', $id)
	));
	$this->addToolButton(array(
        'class' => 'install',
        'title' => 'Парсить выбранные',
        'href'  => null,
        'onclick' => "return icms.datagrid.submit('selected')",
    ));
?>
<style>
.contextMenu{position:absolute;width:120px;z-index:99999;border:1px solid #CCC;background:#EEE;padding:0;margin:0;display:none}.contextMenu LI{list-style:none;padding:0;margin:0}.contextMenu A{color:#333;text-decoration:none;display:block;line-height:20px;height:20px;background-position:6px center;background-repeat:no-repeat;outline:0;padding:1px 5px 1px 28px}.contextMenu LI.hover A{color:#FFF;background-color:#39F}.contextMenu LI.add A{background-image:url("/templates/default/images/icons/add.png")}.contextMenu LI.edit A{background-image:url("/templates/default/images/icons/edit.png")}.contextMenu LI.delete A{background-image:url("/templates/default/images/icons/delete.png")}
</style>
<table class="layout" style="margin-top:0px">
    <tr>
        <td class="sidebar" valign="top">
			<?php if($sources){ ?>
			<select id="source_id" style="width: 100%;">
				<?php foreach($sources as $key => $name){ ?>
					<?php $sel = ($id == $key) ? 'selected' : ''; ?>
					<option value="<?php html($key); ?>" <?php html($sel); ?>><?php html($name['name']); ?></option>
				<?php } ?>
			</select>
			<script>
				$("#source_id").change(function() {
					$("#source_id option:selected").each(function() {
						document.location.href = "/admin/controllers/edit/parsing/sources/" + $(this).val();
					});
				});
			</script>
			<?php } ?>
            <div id="datatree">
                <ul id="treeData" style="display: none">
					<li id="0" class="folder">Все</li>
					<?php if($filters){ ?>
						<?php foreach($filters as $filter){ ?>
							<li id="<?php html($filter['title']); ?>" class="folder"><?php html($filter['title']); ?></li>
						<?php } ?>
					<?php } ?>
                </ul>
            </div>

            <script type="text/javascript">
				function bindContextMenu(span){
					var menu = "myMenu";
					$(span).contextMenu({menu: menu}, function(action, el, pos){
						var node = $.ui.dynatree.getNode(el);
						if(action == 'add'){
							document.location.href = "/admin/controllers/edit/parsing/filter/<?php html($id); ?>";
						}
						if(action == 'edit'){
							var url = "/admin/controllers/edit/parsing/filter/<?php html($id); ?>/"+node.data.key;
							document.location.href = url;
						}
						if(action == 'delete'){
							var url = "/admin/controllers/edit/parsing/filter/<?php html($id); ?>/"+node.data.key+"/delete";
							if (confirm("Удалить фильтр?")) {
							  document.location.href = url;
							} else {
							  return false;
							}
						}
					});
				};
				$(function(){
					$("#datatree").dynatree({
						debugLevel: 0,
						onClick: function(node, event) {
							if( $(".contextMenu:visible").length > 0 ){
								$(".contextMenu").hide();
							}
						},
						onKeydown: function(node, event){
							if($(".contextMenu:visible").length > 0 ){return false;}
							switch(event.which) {
								case 32:
									$(node.span).trigger("mousedown", {
										preventDefault: true,
										button: 2
									})
									.trigger("mouseup", {
										preventDefault: true,
										pageX: node.span.offsetLeft,
										pageY: node.span.offsetTop,
										button: 2
									});
									return false;
							}
						},
						onCreate: function(node, span){
							if($('a', span).text() != 'Все'){
								bindContextMenu(span);
							}
						},
                        onPostInit: function(isReloading, isError){
                            var path = $.cookie('icms[<?php html($id); ?>_path]');
                            if (!path) { path = '/0'; }
                            $("#datatree").dynatree("getTree").loadKeyPath(path, function(node, status){
                                if(status == "loaded") {
                                    node.expand();
                                }else if(status == "ok") {
									node.activate();
                                    node.expand();
                                    icms.datagrid.init();
                                }
                            });
                        },
                        onActivate: function(node){
                            node.expand();
							var c_key = node.getKeyPath();
                            $.cookie('icms[<?php html($id); ?>_path]', node.getKeyPath(), {expires: 7, path: '/'});
                            var key = node.data.key;
                            var url = "<?php echo $this->href_to('ajax', $id) ?>/" + key;
							$('.cp_toolbar .install a').attr('onClick', "return icms.datagrid.submit('/admin/controllers/edit/parsing/selected/<?php html($id); ?>/"+key+"')");
                            icms.datagrid.setURL(url);
                            icms.datagrid.loadRows();
                        }
                    });					
                });
				icms.datagrid.callback = function(){
					var node = $("#datatree").dynatree("getActiveNode");
					$(".actions a").each(function() {
						if(node.data.title != 'Все'){$(this).attr('href', $(this).attr('href') + "/" + node.data.title);}
					});
					$("#datagrid tbody tr td:nth-child(2) a").each(function() {
						if(node.data.title != 'Все'){$(this).attr('href', $(this).attr('href') + "/" + node.data.title);}
					});
					$('.actions .view').attr('onClick', "return icms.modal.openAjax($(this).attr('href'))");
					<?php if($open_new_window){ ?>$('.actions .fields').attr('target', "_blank");<?php } ?>
					$('#datagrid tbody tr td:nth-child(3) a').attr('target', "_blank");
				}
            </script>
        </td>
        <td class="main" valign="top">
            <?php $this->renderGrid($this->href_to('ajax', $id), $grid); ?>
        </td>
    </tr>
</table>
<ul id="myMenu" class="contextMenu">
	<li class="add"><a href="#add">Добавить</a></li>
	<li class="edit"><a href="#edit">Изменить</a></li>
	<li class="delete"><a href="#delete">Удалить</a></li>
</ul>
